<?
/*
Plugin Name: TP-Guestbook
Plugin URI: http://082net.com/tag/tp-guestbook/
Version: 0.9.8
Description: This is modified version of <a href="http://gleamynode.net/wordpress/archives/106/">Threaded and Paged Comments </a> plugin by <a href="http://gleamynode.net/">Trustin Lee</a>:: This plugin helps you make 'Guesbook Page'. You <strong>better</strong> <em>Deactivate</em> or <em>Uninstall</em> currently installed <em>'Threaded Comments'</em> and <em>'Paged Comments'</em>
Author: Cheon, Youngmin
Author URI: http://082net.com
*//*
Change Log ::
v 0.9.8 ::
	Custom-Field changed from paged_comments to tpg_comments
	For fresh install, set var $support_older_version = false;
	You don't have to change comments.php file anymore. (comments_template to tpg_template)
	Added comment_form_position custom field (per post or page value)
	Support comment rss feed on page before WP 2.1
	Fixed broken layout when "Users must be registered and logged in to comment" option is ON
	Support Gravatars plugin(http://www.skippy.net/blog/2005/03/24/gravatars/).

v 0.9.7c ::
	Fixed fancy url bug on wordpress 1.5  - by Hannal (http://www.hannal.com/)
	WP 1.5 users, you don't have to modify .htaccess file but you should "Update Permalink Structure" once.

v 0.9.7b ::
	Added Hemingway theme guestbook template file and css style

v 0.9.7 :: 
	Now TP-Guestbook plugin is class.
	One click Guestbook creation(on option page)
	Threaded and Paged Comments on all posts or pages (You can enable it on option page)
	Updated default CSS style (tpg-default.css)

before v 0.9.6 ::
	Sorry... I can't remember all those changes :( 
	Please check my related posts (http://082net.com/tag/tp-guestbook/)
		
*********************************************************
*Lisense : GNU GPL(http://www.gnu.org/copyleft/gpl.html)					*
*This program is free software; you can redistribute it and/or				*
*modify it under the terms of the GNU General Public License					*
*as published by the Free Software Foundation; either version 2			*
*of the License, or (at your option) any later version.								*
*																												*
*This program is distributed in the hope that it will be useful,				*
*but WITHOUT ANY WARRANTY; without even the implied warranty of	*
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	*
*GNU General Public License for more details.											*
*********************************************************

Original Author ::
Brian's Threaded Comments(1.5.6)		:: Brian Meidell				(http://meidell.dk/)
Paged Comments(V2 (2006-04-07))	:: Keyvan Minoukadeh	(http://www.keyvan.net/)
Threaded and Paged Comments			:: Trustin Lee				(http://gleamynode.net/)
*//*
1. Installation
	a. Upload 'tp-gusetbook' folder to plugins directory (e.g. /wp-content/plugins/ )
	b. Upload 'guestbook.php' to current theme folder (e.g. /wp-content/themes/default/ )
		( guestbook template files(guestbook.php) are in 'themes' folder - included )
	c. If you use other theme, make your own guestbook template. (see http://geeksmakemehot.com/wordpress-guestbook/)
	//===	Replace "comments_template();" with 
	"if (function_exists('tpg_template')) tpg_template(); else comments_template();"	 ===/
	d. Activate 'TP-Guestbook' plugin (Site-admin > plugins)

2. Create 'guestbook' Page
	a. Site-admin > Options > Tp_Guestbook
	b. Click "Create Page" button on top of the TP_Guestbook option page.
	c. That's all

3. Option
	a. Site-admin > Options > TP_Guestbook
	b. Choose the Scheme you would like to use on Guest Book. (if you created one.)
	c. Change other options, if you want.

4. Fancy URL 
	## If Fancy Url = True (in option page)
	// WordPress 1.5 users: you MUST "Update Permalink Structure" once.
	// WordPress 2 users: you don't have to do anything with this.

5. Enjoy :)
*/


if(!class_exists('Pager')) {
	include_once('lib/pager.inc.php');
}

class TPGuestbook {
	var $support_older_version = true;
	var $version = '0.9.8';
	var $show_all_ordering = 'DESC';
	var $default_page = 'auto';
	var $all_posts;
	var $all_pages;
	var $base;
	var $pluginURL;
	var $path;
	var $per_page;
	var $ordering;
	var $page_range;
	var $fancy_url;
	var $show_all_option;
	var $custom_target;
	var $scheme;
	var $fill_last_page;
//	var $shrinkby;
	var $cutoff_level;
	var $formposition;
	var $tpg_id;
	var $page_created;

	function TPGuestbook() {
		$this->base = $this->_basename(__FILE__, true);
		$this->pluginURL = get_settings('siteurl') . '/wp-content/plugins/'.$this->base;
		$this->path = realpath(dirname(__FILE__)) . '/';
		$this->init_options();
		load_plugin_textdomain('tp-guestbook', '/wp-content/plugins/'.$this->base.'/lang');
	}

	function admin_head() {
?>
<style type="text/css">
.green {color: green;}
.red {color: red;}
.blue {color: #1E2C62;}
.big {font-size: 1.2em;}
</style>
<?php 
	}

	function init_options() {
		$tpg_option = get_settings('tpg_options');
		$this->per_page = $tpg_option['per_page'];
		$this->ordering = $tpg_option['ordering'];
		$this->page_range = $tpg_option['page_range'];
		$this->fancy_url = $tpg_option['fancy_url'];
		$this->show_all_option = $tpg_option['show_all'];
		$this->custom_target = $tpg_option['custom_target'];
		$this->scheme = $tpg_option['scheme'];
		$this->fill_last = $tpg_option['fill_last'];
		$this->cutoff_level = $tpg_option['cutoff_level'];
		$this->formposition = $tpg_option['formposition'];
		$this->tpg_id = $tpg_option['tpg_id'];
		$this->page_created = $tpg_option['page_created'];
		$this->all_posts = $tpg_option['all_posts'];
		$this->all_pages = $tpg_option['all_pages'];
	}

	function is_tpg_page() {
		return ( stristr( $_GET['page'], $this->base ) );
	}

	function _basename($file, $dirname=false) {
		$file = preg_replace('|\\\\+|', '\\\\', $file);
		$file = preg_replace('/^.*wp-content[\\\\\/]plugins[\\\\\/]/', '', $file);
		$file = str_replace('\\', '/', $file);
		$file = ($dirname)?dirname($file):$file;
		return $file;
	}

	function _setOptions($reset = false) {
		$guestbook = $this->_createPage(false);
		$options['page_created'] = ($guestbook['id'])?1:0;
		$options['tpg_id'] = ($guestbook['id'])?$guestbook['id']:"";
		$options['scheme'] = "tpg-default.css";
		$options['cutoff_level'] = "4";
		$options['custom_target'] = "wp-comments-post.php";
		$options['per_page'] = "5";
		$options['ordering'] = "DESC";
		$options['page_range'] = "11";
		$options['fancy_url'] = 1; 
		$options['show_all'] = 0;
		$options['fill_last'] = 0;
		$options['formposition'] = "bottom";
		$options['all_posts'] = 0;
		$options['all_pages'] = 0;
		if($reset) 
			update_option("tpg_options", $options);
		else 
			add_option("tpg_options", $options);
	}

	function _setup() {
		if(!get_settings('tpg_options'))
			$this->_setOptions();
	}

	//=====================================
	//=======PAGED COMMENTS START===========
	//=====================================
	function _fancy_url() {
		 $req = rtrim($_SERVER['REQUEST_URI'], '/');
		 if (preg_match('!^(.+/)comment-page-([0-9]+)$!', $req, $match) && (url_to_postid($req) == 0)) {
			  $_GET['cp'] = $match[2];
			  $req = $match[1];
			  $_SERVER['REQUEST_URI'] = $req;
		 } elseif (preg_match('!^(.+/)all-comments$!', $req, $match) && (url_to_postid($req) == 0)) {
			  $_GET['cp'] = 'all';
			  $req = $match[1];
			  $_SERVER['REQUEST_URI'] = $req;
		 }
	}

	function _rewriteRules($rewrite) {
		$new_rewrite['^(.+/)comment-page-([0-9]+)/?$'] = '$1?cp=$2 [QSA,L]';
		$new_rewrite['^(.+/)all-comments/?$'] = '$1?cp=all [QSA,L]';
		return ( $new_rewrite + $rewrite );
	}

	// override default values with custom post values
	function _update_values() {
		 // comments per page
		 $val = $this->_get_custom('comments_per_page');
		 if (!empty($val)) $this->per_page = (int)$val;
		 // comment ordering
		 $val = strtoupper($this->_get_custom('comment_ordering'));
		 if (($val == 'ASC') || ($val == 'DESC')) $this->ordering = $val;
		 // comment form position
		 $val = strtolower($this->_get_custom('comment_form_position'));
		 if($val == 'top' || $val == 'bottom') $this->formposition = $val;
	}

	function _get_custom($field)
	{
		 $val = @get_post_custom_values($field);
		 return trim(@$val[0]);
	}

	// returns true if paged comments are enabled for this post
	function paged_comments() {
		 // paged comments only when viewing a single post or a single page
		 if (!is_single() && !is_page()) return false;
		// has user chosen to view all comments?
		// if so, disable paged comments for this post
		 //if(!(strpos($_GET['cp'], 'all' )===false) && $this->show_all) return false;
		 // has paging been explicitly enabled for this post
		 $tpg_enabled = strtolower($this->_get_custom('tpg_comments'));
		 // support older versions
		 if($this->support_older_version && !$tpg_enabled && !function_exists('paged_comments')) 
			 $tpg_enabled = strtolower($this->_get_custom('paged_comments'));
		 if (is_single()) {
			  // is paging enabled for all posts? return true unless explicitly disabled for this post
			  if ($this->all_posts) { // all_posts on
					return ($tpg_enabled != 'off'); // returns false if explicitly disabled
			  } else { // all_posts off
					return ($tpg_enabled == 'on'); // returns true if explicitly enabled
			  }
		 } else { // is_page()
			  // is paging enabled for all pages? return true unless explicitly disabled for this page
			  if ($this->all_pages) { // all_pages on
					return ($tpg_enabled != 'off'); // returns false if explicitly disabled
			  } else { // all_posts off
					return ($tpg_enabled == 'on'); // returns true if explicitly enabled
			  }
		 }
		 // paging not enabled for this post
		 return false;
	}

	// check for valid show_all request
	function _show_all() {
		 return (($_GET['cp'] == 'all') && $this->show_all);
	}

	// effective ordering
	function _ordering() {
		 if ($this->_show_all()) {
			  return $this->show_all_ordering;
		 } elseif (isset($this->pager) && $this->pager->num_pages() == 1) {
			  return $this->show_all_ordering;
		 } else {
			  return $this->ordering;
		 }
	}

	// initialise pager
	function _init_pager($total_comments) {
		 $this->_update_values();
		 if ($this->_show_all()) {
			  // ensure all comments go on one comment page
			  $this->main_pager =& new Pager($total_comments, $total_comments);
		 } else {
			  $this->main_pager =& new Pager($this->per_page, $total_comments);
		 }
		 $this->pager =& $this->main_pager;
		 if (($this->_show_all() && $this->show_all_ordering == 'DESC') || $this->ordering == 'DESC') {
			  $this->pager =& new InvertedPager($this->pager);
		 }
		 // set page number
		 $page = (int)@$_GET['cp'];
		 if ($page > 0) {
			  $this->pager->set_current_page($page);
		 } elseif ($this->default_page != 'auto') {
			  if ($this->default_page == 'first') {
					$this->main_pager->set_current_page(1);
			  } else {
					$this->main_pager->set_current_page($this->pager->num_pages());
			  }
		 }
	}

	// for mysql LIMIT clause (returns array with offset and limit)
	function _sql_limit() {
		 $remainder = ($this->pager->get_total_items() % $this->per_page);
		 $offset = ($this->main_pager->get_current_page() - 1) * $this->per_page;

		 // alternate descending mode where the last page always contains a fixed number of comments
		 if (($this->ordering == 'DESC') && ($this->fill_last)) {
			  return array($offset, $this->per_page);
		 }
		 // limit clause for comments in ascending order (or if total-comments multiple of comments-per-page)
		 if (($this->ordering == 'ASC') || ($remainder == 0)) {
			  return array($offset, $this->per_page);
		 }
		 // limit clause for comments in descending order (if we're on the last page)
		 if ($this->pager->get_current_page() == $this->pager->num_pages()) {
			  return array(0, $remainder);
		 } else {
			  return array($offset + $remainder - $this->per_page, $this->per_page);
		 }
	}

	// Returns URL to comment $page with the $fragment appended.
	// If $page is null the current comment page is used or a relative 
	// URL (consisting of only the fragment) is returned.
	function _comment_url($fragment='comments', $page=null) {
		global $post;
		if (!isset($page) && ($this->ordering == 'ASC' || isset($_GET['cp']))) return "#$fragment";
		if (!isset($page) && isset($this->pager))	$page = $this->pager->get_current_page();
		$id = $post->ID;
		$qparam = is_page() ? 'page_id' : 'p';
		 if ($this->fancy_url && (get_settings('permalink_structure') != '')) {
			  if ($page == 'all') {
				  return rtrim(get_permalink(), '/')."/all-comments/#$fragment";
			} else {
				return rtrim(get_permalink(), '/')."/comment-page-$page/#$fragment";
			}
		 } else {
			if ($page == 'all') {
				  return get_settings('siteurl').'/'.get_settings('blogfilename')."?$qparam=$id&amp;cp=all#$fragment";
			} else {
				  return get_settings('siteurl').'/'.get_settings('blogfilename')."?$qparam=$id&amp;cp=$page#$fragment";
			}
		 }
	}

	// output page numbers
	function _print_pages() {
		global $post;
		$url = $this->_comment_url('comments', '%u');
		$allurl = $this->_comment_url('comments', 'all');
		$printer =& new PagePrinter($this->pager, $url, $this->page_range);
		$left = '&laquo;'; $right = '&raquo;'; $older = 'Older comments'; $newer = 'Newer comments'; $sep = ' ';
		$link_left = ($this->ordering == 'ASC') ? $printer->get_prev_link($left, $older) : $printer->get_next_link($left, $newer);
		// left arrow link
		if (!empty($link_left)) echo $link_left, $sep;
		// page number links
		echo $printer->get_links($sep);
		// right arrow link
		$link_right = ($this->ordering == 'ASC') ? $printer->get_next_link($right, $newer) : $printer->get_prev_link($right, $older);
		if (!empty($link_right)) echo $sep, $link_right;
		if ($this->show_all_option) echo $sep, '(<a href="'.$allurl.'">Show All</a>)';
	}
	//=====================================
	//=======PAGED COMMENTS END=============
	//=====================================

	//=====================================
	//======THREADED COMMENTS START=========
	//=====================================

	function add_reply_id($id) {
		global $tablecomments, $wpdb;	
		$reply_id = mysql_escape_string($_REQUEST['comment_parent']);
		$q = $wpdb->query("UPDATE $tablecomments SET comment_parent='$reply_id' WHERE comment_ID='$id'");
	}

	function add_reply_id_formfield() {
		print "<p><input type=\"hidden\" id=\"comment_parent\" name=\"comment_parent\" value=\"0\" /></p>";
	}
	//=====================================
	//======THREADED COMMENTS END===========
	//=====================================


	function wp_head($text) {	
		echo '
		<!-- Added by TP-Guestbook '.$this->version.' -->
		<script type="text/javascript" src="'.$this->pluginURL.'/tp-guestbook.js"></script>
		<link rel="stylesheet" href="'.$this->pluginURL.'/css/'.$this->scheme.'" type="text/css" media="screen" />
		';
		return $text;
	}

	function option_page() {
		if (function_exists('add_options_page')) {
			add_options_page("TP_Guestbook", "TP_Guestbook", 9, ''.$this->base.'/tpg-options.php');
		}
	}

	// Create Guestbook page. powered by K2 Theme(http://getk2.com)'s create archive-page tool
	function _createPage($create = true) {
		global $wpdb, $user_ID, $wp_version;
		get_currentuserinfo();
		$check = $wpdb->get_var("SELECT `post_id` from $wpdb->postmeta WHERE meta_key = '_wp_page_template' AND meta_value = 'guestbook.php' LIMIT 1");

		if(!$check) {
			if($create) {
				$message = "You can add your message. this message will be placed upper guestbook form";
				$title_message = 'GuestBook';
				$content = apply_filters('content_save_pre', $message);
				$post_title = apply_filters('title_save_pre', $title_message);
				$post_status = ($wp_version < 2.1)?'static':'publish';
				$post_type = 'page';
				$now = current_time('mysql');
				$now_gmt = current_time('mysql', 1);
				$post_author = $user_ID;
				$id_result = $wpdb->get_row("SHOW TABLE STATUS LIKE '$wpdb->posts'");
				$post_ID = $id_result->Auto_increment;
				$post_name = sanitize_title($post_title, $post_ID);
				$ping_status = get_option('default_ping_status');
				$comment_status = get_option('default_comment_status');
				$postquery ="INSERT INTO $wpdb->posts
					(ID, post_author, post_date, post_date_gmt, post_content, post_title, post_excerpt,  post_status, comment_status, ping_status, post_password, post_name, to_ping, post_modified, post_modified_gmt, post_parent, menu_order, post_type) 
					VALUES 
					('$post_ID', '$post_author', '$now', '$now_gmt', '$content', '$post_title', '', '$post_status', '$comment_status', '$ping_status', '', '$post_name', '', '$now', '$now_gmt', '', '', '$post_type')";
				$result = $wpdb->query($postquery);
				$metaquery = "INSERT INTO $wpdb->postmeta(meta_id, post_id, meta_key, meta_value) VALUES('', '$post_ID', '_wp_page_template', 'guestbook.php')";
				$result2 = $wpdb->query($metaquery);
				$metaquery2 = "INSERT INTO $wpdb->postmeta(meta_id, post_id, meta_key, meta_value) VALUES('', '$post_ID', 'tpg_comments', 'on')";
				$result3 = $wpdb->query($metaquery2);
				return array('create' =>true, 'id' => $post_ID);
			}
			return array('creat' => false, 'id' => false );
		}
		return array('create'=>false, 'id' => $check);
	}

	// TO DO...
	function _deletePage() {
	global $wpdb;
		$check = $wpdb->get_row("SELECT post_id from $wpdb->postmeta WHERE meta_key = '_wp_page_template' AND meta_value = 'guestbook.php'");
		$guestbook_id = $check->post_id;

		if($check) {
			$delete_guestbook = $wpdb->query("DELETE from $wpdb->posts WHERE ID = '$guestbook_id'");
			$delete_guestbook_meta = $wpdb->query("DELETE from $wpdb->postmeta WHERE post_id = '$guestbook_id'");

			$result = $wpdb->query($delete_guestbook);
			$result2 = $wpdb->query($delete_guestbook_meta);
		}
	}

	// Support comment rss on page before WP 2.1
	function comments_rss_on_page($url) {
		if( is_page() && strpos($url, 'withcomments=') === FALSE ) {
			if( '' != get_settings('permalink_structure')) 
				$url .= '?withcomments=1';
			else 
				$url .= '&withcomments=1';
		}
		return $url;
	}

	function comments_template($template_file) {
		$tpg_template = $this->path . 'lib/comments.php';
		if (!$this->paged_comments() || !file_exists($tpg_template)) 
			return $template_file;
		return $tpg_template;
	}

	function &get_instance() {
		static $instance = array();
		if ( empty( $instance ) ) {
			$instance[] =& new TPGuestbook();
		}
		return $instance[0];
	}

}
// end of class

$TPGuestbook =& TPGuestbook::get_instance();

// Actions and Filters
if( $TPGuestbook->is_tpg_page() ) {
	add_action('admin_head', array(&$TPGuestbook, 'admin_head'));
}
if ( $TPGuestbook->fancy_url  ) {
	if( 2 > $wp_version) 
		add_filter('page_rewrite_rules', array(&$TPGuestbook, '_rewriteRules'));
	else 
		add_action('init', array(&$TPGuestbook, '_fancy_url'));
}

if (isset($_GET['activate']) && $_GET['activate'] == 'true') {
	add_action( 'init', array( &$TPGuestbook, '_setup' ) );
}

add_action('admin_menu', array(&$TPGuestbook, 'option_page'));
add_action('wp_head', array(&$TPGuestbook, 'wp_head'));
add_action('comment_post', array(&$TPGuestbook, 'add_reply_id'));
add_action('comment_form', array(&$TPGuestbook, 'add_reply_id_formfield'));
if( $wp_version < 2.1) {
add_filter('post_comments_feed_link', array(&$TPGuestbook, 'comments_rss_on_page'));
}

// Replace Comment Template
add_filter('comments_template', array(&$TPGuestbook, 'comments_template'));

// For support older versions
if(!function_exists('tpg_template')):
function tpg_template($file = 'comments.php') {
	global $TPGuestbook, $tablecomments, $wp_query, $withcomments, $post, $wpdb, $id, $comment, $user_login, $user_ID, $user_identity;
	$include = $TPGuestbook->path . 'lib/' . $file;
	// revert to original comment template if:
	// + the current context is inappropriate (e.g. post listing)
	// + template for paged comments does not exist
	if (!$TPGuestbook->paged_comments() || !file_exists($include)) {
		comments_template();
		return;
	}
	get_currentuserinfo();
	define('COMMENTS_TEMPLATE', true);
	require($include);
}
endif;

?>